'\"
'\" Generated from file 'aitcs\&.man' by tcllib/doctools with format 'nroff'
'\" Copyright (c) 2020 Stuart Cassoff <stwo@users\&.sourceforge\&.net>
'\"
.TH "aitcs" n 2\&.0b1 aitcs "AitCS"
.\" The -*- nroff -*- definitions below are for supplemental macros used
.\" in Tcl/Tk manual entries.
.\"
.\" .AP type name in/out ?indent?
.\"	Start paragraph describing an argument to a library procedure.
.\"	type is type of argument (int, etc.), in/out is either "in", "out",
.\"	or "in/out" to describe whether procedure reads or modifies arg,
.\"	and indent is equivalent to second arg of .IP (shouldn't ever be
.\"	needed;  use .AS below instead)
.\"
.\" .AS ?type? ?name?
.\"	Give maximum sizes of arguments for setting tab stops.  Type and
.\"	name are examples of largest possible arguments that will be passed
.\"	to .AP later.  If args are omitted, default tab stops are used.
.\"
.\" .BS
.\"	Start box enclosure.  From here until next .BE, everything will be
.\"	enclosed in one large box.
.\"
.\" .BE
.\"	End of box enclosure.
.\"
.\" .CS
.\"	Begin code excerpt.
.\"
.\" .CE
.\"	End code excerpt.
.\"
.\" .VS ?version? ?br?
.\"	Begin vertical sidebar, for use in marking newly-changed parts
.\"	of man pages.  The first argument is ignored and used for recording
.\"	the version when the .VS was added, so that the sidebars can be
.\"	found and removed when they reach a certain age.  If another argument
.\"	is present, then a line break is forced before starting the sidebar.
.\"
.\" .VE
.\"	End of vertical sidebar.
.\"
.\" .DS
.\"	Begin an indented unfilled display.
.\"
.\" .DE
.\"	End of indented unfilled display.
.\"
.\" .SO ?manpage?
.\"	Start of list of standard options for a Tk widget. The manpage
.\"	argument defines where to look up the standard options; if
.\"	omitted, defaults to "options". The options follow on successive
.\"	lines, in three columns separated by tabs.
.\"
.\" .SE
.\"	End of list of standard options for a Tk widget.
.\"
.\" .OP cmdName dbName dbClass
.\"	Start of description of a specific option.  cmdName gives the
.\"	option's name as specified in the class command, dbName gives
.\"	the option's name in the option database, and dbClass gives
.\"	the option's class in the option database.
.\"
.\" .UL arg1 arg2
.\"	Print arg1 underlined, then print arg2 normally.
.\"
.\" .QW arg1 ?arg2?
.\"	Print arg1 in quotes, then arg2 normally (for trailing punctuation).
.\"
.\" .PQ arg1 ?arg2?
.\"	Print an open parenthesis, arg1 in quotes, then arg2 normally
.\"	(for trailing punctuation) and then a closing parenthesis.
.\"
.\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
.\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ta \\n()Au \\n()Bu
.ie !"\\$3"" \{\
\&\\$1 \\fI\\$2\\fP (\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
.\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
.\"	# BS - start boxed text
.\"	# ^y = starting y location
.\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
.\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
.\"	# VS - start vertical sidebar
.\"	# ^Y = starting y location
.\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
.\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
.\"	# Special macro to handle page bottom:  finish off current
.\"	# box/sidebar if in box/sidebar mode, then invoked standard
.\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
.\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
.\"	# DE - end display
.de DE
.fi
.RE
.sp
..
.\"	# SO - start of list of standard options
.de SO
'ie '\\$1'' .ds So \\fBoptions\\fR
'el .ds So \\fB\\$1\\fR
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 5.5c 11c
.ft B
..
.\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\*(So manual entry for details on the standard options.
..
.\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
.\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
.\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.\"	# UL - underline word
.de UL
\\$1\l'|0\(ul'\\$2
..
.\"	# QW - apply quotation marks to word
.de QW
.ie '\\*(lq'"' ``\\$1''\\$2
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\$2
..
.\"	# PQ - apply parens and quotation marks to word
.de PQ
.ie '\\*(lq'"' (``\\$1''\\$2)\\$3
.\"" fix emacs highlighting
.el (\\*(lq\\$1\\*(rq\\$2)\\$3
..
.\"	# QR - quoted range
.de QR
.ie '\\*(lq'"' ``\\$1''\\-``\\$2''\\$3
.\"" fix emacs highlighting
.el \\*(lq\\$1\\*(rq\\-\\*(lq\\$2\\*(rq\\$3
..
.\"	# MT - "empty" string
.de MT
.QW ""
..
.BS
.SH NAME
aitcs \- Array in the Command's Shadow
.SH SYNOPSIS
package require \fBTcl  8\&.6\fR
.sp
package require \fBaitcs  ?2\&.0b1?\fR
.sp
namespace import ::aitcs::aitcs
.sp
namespace import ::aitcs::aitcs+
.sp
\fBaitcs  new\fR ?\fIname\fR? ?\fI-option value \&.\&.\&.\fR? ?\fI--\fR? ?\fIkey value \&.\&.\&.\fR?
.sp
\fBaitcs+ new\fR ?\fIname\fR? ?\fI-option value \&.\&.\&.\fR? ?\fI--\fR? ?\fIkey value \&.\&.\&.\fR?
.sp
\fBaitcs  operators\fR
.sp
\fBaitcs+ operators\fR
.sp
\fBname!\fR
.sp
\fBname\fR \fIkey\fR ?\fIvalue\fR? ?\fIkey value \&.\&.\&.\fR?
.sp
\fBname?\fR \fIkey\fR ?\fImyVar\fR?
.sp
\fBname-\fR \fIkey\fR ?\fIkey \&.\&.\&.\fR?
.sp
\fBname^\fR \fIkey\fR ?\fIdefault\fR? ?\fImyVar\fR?
.sp
\fBname&\fR ?\fIkey\fR?
.sp
\fBname&&\fR
.sp
\fBname->\fR \fIkey?op?\fR ?\fIarg \&.\&.\&.\fR?
.sp
\fBname---\fR
.sp
\fBname=\fR \fIkey\fR ?\fIkey \&.\&.\&.\fR? \fIvalue\fR
.sp
\fBname+\fR \fIkey\fR ?\fIvalue \&.\&.\&.\fR?
.sp
\fBname+=\fR \fIkey\fR ?\fIincr \&.\&.\&.\fR?
.sp
.BE
.SH DESCRIPTION
Array in the Command's Shadow
provides a convenient way to access and manipulate
arrays in namespaces by offering a higher level
of abstraction for certain array operations\&.
.PP
An AitCS is an array with an associated set of commands
that access or manipulate the array\&.
Array accesses are via commands instead of referring to
the array as a variable\&. The array is still an array,
but there is now a set of commands that "know" the array\&.
.PP
An AitCS is designed to be used where a program would
normally use global or namespace variables to hold
configuration, state, widget paths, temp values, etc\&.
.PP
As opposed to namespace ensembles and objects, AitCS doesn't
create one command and then dispatch on operators (subcommands)\&.
Instead, one command is created for each operator, with
the name of the operator attached to the command\&.
.PP
For get/set operations, the command (the name of the AitCS)
is used like Tcl's [set] command\&.
.PP
Regular:
.CS


	namespace eval myns {
		variable myarr
		set myarr(a) 1

		proc myproc1 {} {
			variable myarr
			if {![info exists myarr(b)]} {
				set myarr(b) [expr {$myarr(a) + 1}]
			}
		}

		proc myproc2 {} {
			variable myarr
			puts $myarr(b)
		}

		myproc1; myproc2
	}

.CE
AitCS:
.CS


	namespace eval myns {
		aitcs new myarr
		myarr a 1

		proc myproc1 {} {
			if {![myarr? b]} {
				myarr b [expr {[myarr a] + 1}]
			}
		}

		proc myproc2 {} {
			puts [myarr b]
		}

		myproc1; myproc2
	}

.CE
.PP
An AitCS is one array and nine commands\&.
The commands access and manipulate the array itself\&.
.PP
An AitCS+ is one array and twelve commands\&.
An AitCS+ is identical to an AitCS, with the exception of three additional commands\&.
The additional commands access and manipulate the contents of array elements\&.
.PP
The array is created in a namespace and the commands
are created in a (possibly different) namespace\&.
.PP
All references to array variables, elements, or commands
produced by AitCS are fully qualified\&.
.PP
Destroying the array by any means other than by the "---"
operator will only destroy the array, not the commands\&.
There are no traces or other connections between the commands
and the array; the commands only know the array's name\&.
.PP
An AitCS can have a random name or a user-supplied name\&.
The actual array name is a concatenation of the name,
a random string of characters, and some underscores
for good measure\&. This is like an opaque pointer in that
a human doesn't need to know the actual name of the array\&.
Having randomly-generated names can help with writing fewer
bugs as code will be less dependent on hardcoded variable
names\&.
.PP
AitCS helps to reduce complications with namespaces,
makes for cleaner code, and saves typing\&.
.PP
AitCS works with Jim as well as with Tcl\&.
.SH COMMANDS
.TP
\fBaitcs  new\fR ?\fIname\fR? ?\fI-option value \&.\&.\&.\fR? ?\fI--\fR? ?\fIkey value \&.\&.\&.\fR?
.TP
\fBaitcs+ new\fR ?\fIname\fR? ?\fI-option value \&.\&.\&.\fR? ?\fI--\fR? ?\fIkey value \&.\&.\&.\fR?
Creates a new array in the namespace \fIvariable_namespace\fR
and creates commands to manipulate the array in the
namespace \fIcommand_namespace\fR\&.
.sp
If the \fIname\fR isn't supplied or is an empty string
then the \fIname\fR will be set to a string of six
random characters in the range a-z\&.
An error will be returned if a unique random command in the \fIcommand_namespace\fR
can't be created after one thousand attempts\&. This should never happen?
.sp
If the \fIvariable_namespace\fR isn't supplied or
is an empty string then it will be set to the caller's namespace\&.
.sp
If the \fIcommand_namespace\fR isn't supplied or is an empty string
then the \fIcommand_namespace\fR will be set to the \fIvariable_namespace\fR\&.
.sp
The array will be created as "variable_namespace::__name__cccccc_"
where "cccccc" is six random characters in the range a-z\&.
.sp
If the command already exists or any of the required namespaces don't exist
then an error will be returned and neither array nor commands will be created\&.
.sp
Initial values are set from \fIkey value \&.\&.\&.\fR if supplied\&.
.sp
Creates an array variable in the \fIvariable_namespace\fR and
associated commands in the \fIcommand_namespace\fR\&.
.sp
Returns the fully qualified name of the array's set/get command\&.
.sp
Options
.RS
.TP
\fB\fB-cns namespace\fR\fR
.TP
\fB\fB-command_namespace namespace\fR\fR
Set the command namespace\&.
.TP
\fB\fB-vns namespace\fR\fR
.TP
\fB\fB-variable_namespace namespace\fR\fR
Set the variable namespace\&.
.TP
\fB\fB--\fR\fR
End option processing\&. Any remaining arguments become initializers\&.
.RE
.TP
\fBaitcs  operators\fR
Returns a list of all the AitCS operators\&.
.TP
\fBaitcs+ operators\fR
Returns a list of all the AitCS+ operators\&.
.PP
.SH "AITCS COMMANDS"
AitCS commands are created in the \fIcommand_namespace\fR and
are based on the name supplied when the AitCS was created\&.
.PP
The following commands are common to an AitCS and an AitCS+\&.
.TP
\fBname!\fR
Brings the array into existence in the current context\&.
This is \fBupvar\fR \fI#0\fR \fIvarname\fR \fIname\fR\&.
From then on in the current context the array can be referenced by name\&.
Returns an empty string\&.
Nickname: Make Exist\&.
.TP
\fBname\fR \fIkey\fR ?\fIvalue\fR? ?\fIkey value \&.\&.\&.\fR?
Gets the value of one element of the array or sets the value of one or more elements of the array\&.
The value(s) for the key(s) will be set using \fBarray set\fR\&.
Returns the value at \fIkey\fR\&.
Nickname: Get/Set\&.
.TP
\fBname?\fR \fIkey\fR ?\fImyVar\fR?
Returns true if the \fIkey\fR exists in the array or false if the \fIkey\fR doesn't exist in the array\&.
If the \fIkey\fR exists and \fImyVar\fR is supplied and is not an empty string then the variable it names
will be set in the caller's context to the value at \fIkey\fR\&.
Nickname: Exists\&.
.TP
\fBname-\fR \fIkey\fR ?\fIkey \&.\&.\&.\fR?
Removes key(s) from the array\&. The \fBarray unset\fR command is used, allowing key(s) to contain wildcards\&.
It isn't an error if a key doesn't exist in the array\&.
Returns an empty string\&.
Nickname: Unset\&.
.TP
\fBname^\fR \fIkey\fR ?\fIdefault\fR? ?\fImyVar\fR?
Returns the value at \fIkey\fR if it exists,
otherwise returns \fIdefault\fR, or an empty string if \fIdefault\fR isn't supplied\&.
If \fImyVar\fR is supplied and is not an empty string then the variable it names
will be set in the caller's context to the returned value\&.
Nickname: Get With Default\&.
.TP
\fBname&\fR ?\fIkey\fR?
Returns the fully namespace qualified name of the array if no \fIkey\fR supplied or if \fIkey\fR is an empty string,
otherwise returns the fully namespace qualified name of the array and the element \fIkey\fR\&.
Nickname: Variable Reference\&.
.TP
\fBname&&\fR
Returns the fully namespace qualified command\&.
Nickname: Command Reference\&.
.TP
\fBname->\fR \fIkey?op?\fR ?\fIarg \&.\&.\&.\fR?
The \fIkey\fR should be another AitCS\&. Permits "nesting"\&. Calls are chained\&.
Nickname: Struct Dereference\&.
.TP
\fBname---\fR
Unsets the array and deletes all the commands\&.
Returns an empty string\&.
Nickname: Destroy\&.
.PP
The following commands are only provided by an AitCS+\&.
.TP
\fBname=\fR \fIkey\fR ?\fIkey \&.\&.\&.\fR? \fIvalue\fR
Every \fIkey\fR is set to \fIvalue\fR\&.
Returns \fIvalue\fR\&.
Nickname: Setto\&.
.TP
\fBname+\fR \fIkey\fR ?\fIvalue \&.\&.\&.\fR?
Every \fIvalue\fR is \fBlappend\fRed to the element at \fIkey\fR\&.
Returns the value at \fIkey\fR\&.
Nickname: Lappend\&.
.TP
\fBname+=\fR \fIkey\fR ?\fIincr \&.\&.\&.\fR?
Increments the value at \fIkey\fR by all \fIincr\fR arguments (default 1)\&.
Returns the value at \fIkey\fR\&.
Nickname: Incr\&.
.PP
.SH EXAMPLES
.CS



	# Set/Get/Variable Reference
	# Save a widget and link a textvariable
	aitcs new rec
	aitcs new gui
	set fld preference
	rec $fld Tcl
	gui $fld [entry \&.e -textvariable [rec& $fld]]
	[gui $fld] insert end /Tk
	string length [rec preference]; # 6

	# Get/Set
	aitcs new things
	things a 3
	things b [expr {[things a] + 2}]
	things c [expr {[things b] * [things a]}]
	things c; # 15

	# Exists
	aitcs new colours
	colours red #FF0000
	colours? red; # 1
	colours? green; # 0
	colours? red color1; # 1
	info exists color1; # 1
	set color1; # #FF0000
	colours? green color2; # 0
	info exists color2; # 0

	# Setto/Exists/Unset/Variable Reference
	aitcs+ new fruits
	fruits= apple orange pear apricot 0
	if {![fruits? peach]} {
		fruits= peach 0
	}
	array names [fruits&]; # {apple orange pear apricot peach}
	fruits- p* a*
	array names [fruits&]; # {orange}

	# Get With Default
	aitcs new things
	things are good
	things^ are ok; # good
	things^ be ok; # ok
	things^ willbe; # Empty string
	things^ is nice here; # nice, and var here is set to nice

	# Lappend
	aitcs+ new store
	store this one
	store+ this two three four five
	store this; # {one two three four five}

	# Incr
	aitcs+ new counters
	counters cycles 0
	counters+= cycles
	counters+= cycles 2
	counters+= cycles 3 -4 1
	counters cycles; # 3

	# Make Exist/Exists
	aitcs new cow
	cow!
	set cow(sound) moo
	if {[cow? sound] && $cow(sound) eq "moo"} {
		puts "Standard English Cow"
	}

	# Command Reference/Variable Reference/Incr
	aitcs new callback
	callback count 0
	after 1000 [list [callback&&]+= count]
	vwait [callback& count]
	callback count; # 1

	# Struct Dereference/Random Name/Initial Values
	aitcs new animals
	animals dog  [aitcs new {} {} {} says woof likes cat]
	animals cat  [aitcs new {} {} {} says meow likes dog]
	animals home [list dog cat]
	set res ""
	foreach animal [animals home] {
		append res $animal " says " [animals-> $animal says]
		append res " likes " [animals-> $animal likes]
		append res " who says " [animals-> [animals-> $animal likes] says]\\n
	}
	set res
	# dog says woof likes cat who says meow
	# cat says meow likes dog who says woof

	# Struct Dereference
	aitcs+ new outer
	aitcs+ new inner
	aitcs+ new innest
	inner count 6
	innest things [list]
	innest+ things 1 2
	outer member inner
	inner item innest
	outer-> member+= count 2; # 8
	outer-> member-> item+ things 3 4; # {1 2 3 4}
	outer-> member-> item^ name; # Empty string

	# Destroy
	aitcs+ new tmp
	tmp count 5
	tmp+= count -1
	tmp count; # 4
	set fqarr [tmp&]
	info exists $fqarr; # 1
	tmp---
	info exists $fqarr; # 0
	tmp count; # <error>


.CE
.SH HISTORY
The inspiration came from being tired of
having to use the \fBvariable\fR command
in almost all the commands in a namespace when
often in a given command there is usually interest in
only a few items of the "global" state\&.
.PP
To maintain the smallest possible set of commands,
the necessity and usefulness of each command was
carefully considered before including it in AitCS\&.
All commands were written and tested to be as fast as possible\&.
.PP
The "&" operator was inspired by C: obtaining a "reference" to an element of an array\&.
The "&&" operator was inspired the "&" operator\&.
The "^" operator was inspired by the XOR operator: result is one or the other\&.
The "->" operator was inspired by C structures\&. Originally "\&." but changed for greater readability\&.
The "!" operator is excitement: something has just come into existence!
The "?" operator is the obvious choice for its function\&.
The "-" operator generally means "remove something"\&.
The "+" operator generally means "add something"\&.
The "+=" operator was inspired by C\&.
For the "---" (destroy) operator, three dashes were
chosen because two would be too easily confused with
C's "--", and it is reminiscent of "===" in other
languages, which carries a meaning of "really serious this time"\&.
.SH BUGS
In the interest of speed, the AitCS commands don't check anything\&.
Errors reported will be errors occurring inside the AitCS commands\&.
For example, attempting to retrieve the value of a nonexistent
element will result in a "no such element in array" error somewhere
within the AitCS command\&.
.SH KEYWORDS
array, command, eagle, namespace, snake
.SH CATEGORY
Programming tools
.SH COPYRIGHT
.nf
Copyright (c) 2020 Stuart Cassoff <stwo@users\&.sourceforge\&.net>

.fi
